import { pathOr, propOr } from 'ramda';

import { createSelector } from 'reselect';

import { APIReducer } from '@treejs/api/types';
import { EMPTY_OBJECT } from '@treejs/constants/empty';
import { ROOT_REDUCER_NAME } from '@treejs/constants/redux';

const root = pathOr(EMPTY_OBJECT, [ROOT_REDUCER_NAME, 'fetch']);

export const getIsFetching = createSelector(
	root,
	(state: any, fetchUrl: string) => fetchUrl,
	(state, url): boolean => {
		const fetchState: APIReducer = propOr({}, url, state);
		return propOr(false, 'isFetching', fetchState);
	}
);
