import { createSlice } from '@reduxjs/toolkit';

import { API_REDUCER_NAME } from './constants';

const fetchSlice = createSlice({
	name: API_REDUCER_NAME,
	initialState: {},
	reducers: {
		onRequest: (state, action) => {
			return {
				...state,
				[`${action.payload.url}.${action.payload.method}`]: {
					isFetching: true,
					isError: false,
				},
			};
		},
		onSuccess: (state, action) => {
			return {
				...state,
				[`${action.payload.url}.${action.payload.method}`]: {
					isFetching: false,
					isError: false,
				},
			};
		},
		onError: (state, action) => {
			return {
				...state,
				[`${action.payload.url}.${action.payload.method}`]: {
					isFetching: false,
					isError: true,
				},
			};
		},
	},
});

export const { onRequest, onSuccess, onError } = fetchSlice.actions;
export default fetchSlice.reducer;
