export enum FetchMethod {
	DELETE = 'delete',
	GET = 'get',
	PATCH = 'patch',
	POST = 'post',
	PUT = 'put',
}

export enum ACTIONS {
	FETCH = 'API_FETCH/FETCH',
}

export type QueryParams = {
	[key: string]: string;
};

export type FetchConfig<C> = {
	baseUrl?: string;
	body?: any;
	headers?: { [key: string]: string };
	method: FetchMethod;
	onError?: (response: any) => void;
	onRequest?: () => void | Promise<void>;
	onSuccess?: (response: any) => void | Promise<void>;
	queryParams?: QueryParams;
	url: string;
} & C;

export type FetchState = {
	isError: boolean;
	isFetching: boolean;
};

export enum FetchShape {
	input,
}

export type APIReducer = {
	[key: string]: FetchState;
};
