import { Action } from '@treejs/types/redux/actions';

import { ACTIONS, IAuthOption } from './types';

export type SetAuthenticatedPayload<P> = IAuthOption<P>;
export const setAuthenticated = <P>(
	payload: SetAuthenticatedPayload<P>
): Action<SetAuthenticatedPayload<P>, ACTIONS> => ({
	type: ACTIONS.SET_AUTHENTICATED,
	payload: payload,
});

type Keys<P> = keyof IAuthOption<P>;
type Values<P> = IAuthOption<P>[Keys<P>];
export type UpdateAuthenticatedPayload<P> = {
	key: Keys<P>;
	value: Values<P>;
};
export const updateAuthenticated = <P>(key: Keys<P>, value: Values<P>): Action<any, ACTIONS> => ({
	type: ACTIONS.UPDATE_AUTHENTICATED,
	payload: {
		key,
		value,
	},
});
