import { SetAuthenticatedPayload, UpdateAuthenticatedPayload } from '@treejs/auth/actions';
import { Action } from '@treejs/types/redux/actions';

import { ACTIONS, AuthReducer } from './types';

const initialState: AuthReducer<any> = {
	authenticated: false,
	accessToken: null,
	refreshToken: null,
	userId: null,
};

type Payload = SetAuthenticatedPayload<any> | UpdateAuthenticatedPayload<any>;

const reducer = (state = initialState, action: Action<Payload, ACTIONS>): AuthReducer<any> => {
	switch (action.type) {
		case ACTIONS.SET_AUTHENTICATED:
			return {
				...state,
				...action.payload,
			};
		case ACTIONS.UPDATE_AUTHENTICATED:
			return {
				...state,
				[action.payload.key]: action.payload.value,
			};
		default:
			return state;
	}
};

export default reducer;
