import { prop } from 'ramda';

import { createSelector } from 'reselect';

import { ROOT_REDUCER_NAME } from '@treejs/constants/redux';

import { AUTH_REDUCER_NAME } from './constants';
import { IAuthOption } from './types';

export const getRoot = <P>(state: any): IAuthOption<P> => state[ROOT_REDUCER_NAME][AUTH_REDUCER_NAME];

export const isAuthenticated = createSelector(getRoot, (state): boolean => prop('authenticated')(state));

const getAttribute = createSelector(
	getRoot,
	(state: any, attributeName: any): string => attributeName,
	(state, attributeName): string => prop(attributeName)(state) as string
);

export const getAuthenticateAttribute = (state: any, attributeName: string): string =>
	getAttribute(state, attributeName);
