import { dissoc } from 'ramda';

import { Action } from '@treejs/types/redux/actions';

import { ACTIONS, ModalReducer, ModalState } from '../types';

const initialState: ModalReducer = {};

type Payload = ModalState;

const reducer = (state = initialState, action: Action<Payload, ACTIONS>): ModalReducer => {
	switch (action.type) {
		case ACTIONS.ADD_MODAL:
			return {
				...state,
				[action.payload.id]: {
					visible: true,
					...action.payload,
				},
			};
		case ACTIONS.REMOVE_MODAL:
			return dissoc(action.payload.id, state);
		default:
			return state;
	}
};

export default reducer;
