const path = require('path');
const plugin = require('tailwindcss/plugin');

const theme = require('./theme/main');

module.exports = {
	purge: {
		enabled: true,
		content: [path.resolve(__dirname + '../../../**/*.{js,ts,tsx}')],
		options: {
			safelist: {
				standard: [/[:]?col-/, /[:]?grid/, /[:]?gap/, /[:]?text-[\d]?xl/, /[:]?m[tlbrxy]?-\d/],
			},
		},
	},
	darkMode: false,
	theme: {
		extend: theme,
	},
	plugins: [
		plugin(require('./components/button')),
		plugin(require('./components/field')),
		plugin(require('./components/message')),
		plugin(require('./components/skeleton')),
		plugin(require('./components/table')),
		plugin(require('./components/grid')),
	],
	corePlugins: {
		float: false,
	},
};
