import React from 'react';

import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import cx from 'classnames';

import { OptionRenderProps } from '@treejs/components/RadioButton/types';

const CustomRender: React.FC<OptionRenderProps> = ({ option: { code, name }, value }): React.ReactElement => {
	return (
		<div>
			{code === 'natural' && (
				<div
					className={cx('text-center p-2', {
						'bg-primary text-white': value === 'natural',
					})}
				>
					<FontAwesomeIcon size="lg" icon={'user-tie'} />
					<div className="mt-1">{name}</div>
				</div>
			)}
			{code === 'legal' && (
				<div
					className={cx('text-center p-2', {
						'bg-primary text-white': value === 'legal',
					})}
				>
					<FontAwesomeIcon size="lg" icon={'building'} />
					<div className="mt-1">{name}</div>
				</div>
			)}
		</div>
	);
};

export default CustomRender;
